/*
    setinfo
    version 1.0 Copyright (C) 2007 Tagata Akira

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
    02110-1301 USA

*/

/****************************************************************
  Warning.  This program specifications including API may change
  because of beta version.
****************************************************************/

_setinfo.prototype = new _fss('setinfo','setinfo','1.0beta','2007 Tagata Akira','http://www.tagata.org/software/');

//-fxref-// _setinfo: _fss

_setinfo.prototype.infoMarkId = 'setinfo-info-mark';
_setinfo.prototype.infoMarkTagName = 'div';
_setinfo.prototype.infoMarkText = 'i';
_setinfo.prototype.infoMarkStyle = {
	position: 'absolute',
//	position: 'fixed',
	top: '1em',
	right: '1em',
	backgroundColor: '#000099',
	border: '1px outset #000099',
	color: '#ffffff',
	fontFamily: 'serif',
	fontWeight: 'bolder',
	padding: '0 0.5ex',
	cursor: 'help'
};

_setinfo.prototype.infoMessageId = 'setinfo-info-message';
_setinfo.prototype.infoMessageTagName = 'div';
_setinfo.prototype.infoMessageText = 'n/a';
_setinfo.prototype.infoMessageStyle = {
	position: 'absolute',
	top: '1.5em',
	right: '1.5em',
	width: '10em',
	backgroundColor: '#ffffff',
	lineHeight: '125%',
	border: '1px solid #000099',
	color: '#000099',
	padding: '1ex'
};

_setinfo.prototype.delayOn = 500;
_setinfo.prototype.delayOff = 500;

_setinfo.prototype.styleOn = { display: 'block' };
_setinfo.prototype.styleOff = { display: 'none' };

function _setinfo(infoMark,infoMessage,waitIn,timeIn,waitOut,timeOut,delayOn,delayOff,option) {

	if (typeof infoMark == 'string') {
		this.infoMarkText = infoMark;
	}
	else if (typeof infoMark == 'object') {
		if (infoMark.id) this.infoMarkId = infoMark.id;
		if (infoMark.tagName) this.infoMarkTagName = infoMark.tagName;
		if (infoMark.text) this.infoMarkText = infoMark.text;
		if (infoMark.style) this.infoMarkStyle = infoMark.style;
	}

	if (typeof infoMessage == 'string') {
		this.infoMessageText = infoMessage;
	}
	else if (typeof infoMessage == 'object') {
		if (infoMessage.id) this.infoMessageId = infoMessage.id;
		if (infoMessage.tagName) this.infoMessageTagName = infoMessage.tagName;
		if (infoMessage.text) this.infoMessageText = infoMessage.text;
		if (infoMessage.style) this.infoMessageStyle = infoMessage.style;
	}

	if (delayOn)  this.delayOn  = delayOn;
	if (delayOff) this.delayOff = delayOff;

//	var infoMarkElement = this.elementIdentified(this.infoMarkId,this.infoMarkTagName);
	var infoMarkElement = _fss.elementIdentified(this.infoMarkId,this.infoMarkTagName);
	if (infoMarkElement._fssGenerated && !infoMarkElement._fssGeneratedEver) {
		infoMarkElement.appendChild(document.createTextNode(this.infoMarkText));
		if (this.infoMarkStyle)
			_fss.setStyleSheetData(infoMarkElement,this.infoMarkStyle);
		document.body.appendChild(infoMarkElement);
}

//	var infoMessageElement = this.elementIdentified(this.infoMessageId,this.infoMessageTagName);
	var infoMessageElement = _fss.elementIdentified(this.infoMessageId,this.infoMessageTagName);
	if (infoMessageElement._fssGenerated && !infoMessageElement._fssGeneratedEver) {
		infoMessageElement.appendChild(document.createTextNode(this.infoMessageText));
		if (this.infoMessageStyle)
			_fss.setStyleSheetData(infoMessageElement,this.infoMessageStyle);
		infoMarkElement.appendChild(infoMessageElement);
	}


//-fxref-// _setinfo: _fss.elementIdentified _fss.setStyleSheetData

	infoMarkElement.$i = infoMessageElement;
	if (this.styleSilhouette) {
		infoMarkElement.$s = document.createElement('div');
//		infoMarkElement.$s.style.position = 'absolute';
		_fss.setStyleSheetData(infoMarkElement.$s,this.styleSilhouette);
		_fss.setStyleSheetData(infoMarkElement.$s,this.styleOff);
		infoMarkElement.$i.parentNode.insertBefore(infoMarkElement.$s,infoMarkElement.$i);
	}

	_fss.setStyleSheetData(infoMarkElement.$i,this.styleOff);

	this.fio = new _fio(infoMarkElement.$i,waitIn,timeIn,waitOut,timeOut,option);

//-fxref-// _setinfo: _fio

	// momo

	function handlerMouseOverDelayed(elt,e) {
		if (elt.$o.fio && !elt.$o.fio.finished()) {
			elt.$o.fio.cancel(true);
			elt.$o._log('_setinfo(): called fio.cancel()');
		}
		if (!elt.$o.fio || elt.$o.fio.finished()) {
			_fss.setStyleSheetData(elt.$i,elt.$o.styleOn);
			if (elt.$s) {
				elt.$s.style.width = elt.$i.offsetWidth + 'px';
				elt.$s.style.height = elt.$i.offsetHeight + 'px';
				_fss.setStyleSheetData(elt.$s,elt.$o.styleOn);
			}
		}
		return true;
	}

	function handlerMouseOutDelayed(elt,e) {
		if (!elt.fio || elt.$o.fio.finished()) {
			_fss.setStyleSheetData(elt.$i,elt.$o.styleOff);
			if (elt.$s)
				_fss.setStyleSheetData(elt.$s,elt.$o.styleOff);
		}
		return true;
	}


	infoMarkElement.$o = this;
	this.mo = new _fss.momo(infoMarkElement,{
		msec: {
			onDelayed:	this.delayOn,
			offDelayed:	this.delayOff,
			keepStaying:	0
		},
		um: {
			mouseOverDelayed:	handlerMouseOverDelayed,
			mouseOutDelayed:	handlerMouseOutDelayed
		}});

//-fxref-// _setinfo: _fss.momo

	_setinfo.prototype._fssInsertUrl();
}
